;
; IRQ Vector and Service Routines
;
; Copyright 2002 by Thorsten Klose
; Commercial use without my permission is strictly forbidden!
;


;; ==========================================================================
;;  IRQ Vector
;; ==========================================================================

	ORG	0x0004

IRQ
	movwf	W_TMP
	swapf	STATUS, W
	clrf	STATUS		; switch to bank 0
	movwf	STATUS_TMP
	movf	FSR, W
	movwf	FSR_TMP
	
IRQCheck
	; which IRQ received?
	IFSET	PIR1, RCIF, 	goto IRQ_UART_Receive	; UART Receive IRQ?
IRQEnd
	movf	FSR_TMP, W
	movwf	FSR
	swapf	STATUS_TMP, W
	movwf	STATUS
	swapf	W_TMP, F
	swapf	W_TMP, W
	retfie
	
;; ==========================================================================
;;  IRQ Handler for UART Receiver
;; ==========================================================================
IRQ_UART_Receive
	bcf	PIR1, RCIF

	incf	RINGBUFFER0_A, F
	movf	RINGBUFFER0_A, W
	xorlw	RINGBUFFER0_END+1
	bnz	IRQ_UART_NoRingAReset
	movlw	RINGBUFFER0
	movwf	RINGBUFFER0_A
IRQ_UART_NoRingAReset
	movf	RINGBUFFER0_A, W
	movwf	FSR
	movf	RCREG, W
	movwf	INDF

IRQ_UART_End
	goto	IRQCheck
