;
; Source Code of MIDI Filter/Processor
; Copyright 2002 by Thorsten Klose
; All rights reserved.
; Commercial use without my permission is strictly forbidden!
;
; EMail: Thorsten.Klose@gmx.de
; Homepage: http://www.uCApps.de
;
;; ==========================================================================

#include "midibox.h"
#include "macros.h"

; ==========================================================================
;   !!! customizations have to be done in proc.inc !!!
; ==========================================================================
; Explanations of the include files
;
;  CODE PAGE #0
;    midibox.h:    A lot of flags, defines, register locations
;    macros.h:     my private macros
;    reset.inc:    reset handler
;    irq.inc:      interrupt handler, the MIDI IN part
;    init.inc:	   various initialization routines
;    midi.inc:	   Send and Learn MIDI
;    proc.inc:	   Filter/Process MIDI Events
;    mainloop.inc: The MIDI Receive Handler
; ==========================================================================

	;; org in include file
#include "reset.inc"
#include "irq.inc"
#include "init.inc"
#include "midi.inc"


;; use one of these include files to test the examples, comment out all others!
#include "proc.inc"
;; #include "procex1.inc"
;; #include "procex2.inc"
;; #include "procex3.inc"
;; #include "procex4.inc"

Start
	call	Init
#include "mainloop.inc"

	org	0x0780
#include "contab.inc"

;; ==========================================================================

	END
